package Package1;

public class Cbr {

    static String decodeNcPc(int currentPitch) {
        String notes = "CDEFGAB";
        char name = notes.charAt((currentPitch % 1000) % 10);
        int[] offset = {0, 2, 4, 5, 7, 9, 11};
        // si utilizza l'nc per vedere lo spiazzamento in termini di pc della nota naturale
        int naturalPc = offset[(currentPitch % 1000) % 10];
         // pc della nota inserita - pc della nota naturale
        int offsetPc = ((currentPitch % 1000) / 10) - naturalPc;

        // decodifica del valore ottenuto in termini di alterazioni  
        String accidental = "";
        for (int j = 0; j < Math.abs(offsetPc); j++) {
            if (offsetPc < 0) {
                accidental += "b";
            } else {
                accidental += "#";
            }
        }
        accidental = accidental.replace("##", "x");

        return (name + accidental);
    }

    static int decodeOctave(int currentPitch) {
        return currentPitch / 1000;
    }

    public static void main(String[] args) {
        if (args.length < 1) {
            System.out.println("E' necessario immettere almeno un argomento");
            System.exit(1);
        }

        int[] cbrSequence = new int[args.length];
        try {
            for (int i = 0; i < args.length; i++) {
                cbrSequence[i] = Integer.parseInt(args[i]);
                // verifica sulla correttezza della codifica cbr in ingresso: NC e PC
                if ((cbrSequence[i] % 10 > 6) || ((cbrSequence[i] % 1000) / 10) > 11) {
                    System.out.println("Valore immesso non valido nella codifica CBR: " + cbrSequence[i]);
                    System.exit(1);
                }
            }
        } catch (NumberFormatException e) {
            System.out.println("Gli argomenti devono essere di tipo intero");
            System.exit(1);
        }

        for (int currentPitch : cbrSequence) {
            System.out.print("Valore immesso: " + currentPitch);
            System.out.print(" -> ottava: " + currentPitch / 1000 + ",");
            System.out.print(" PC: " + (currentPitch % 1000) / 10 + ",");
            System.out.println(" NC: " + (currentPitch % 1000) % 10);
            System.out.println(decodeNcPc(currentPitch) + decodeOctave(currentPitch));
            System.out.println();
        }
    }

}
