package Package1;


import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.TransformerException;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class JavaXPath {

    public static void main(String[] args) throws TransformerException {
        try {
            DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
            DocumentBuilder docBuilder = docFactory.newDocumentBuilder();
            Document myXmlDocument = docBuilder.parse("gounod_ave_maria.xml");

            XPathFactory myXPathFactory = XPathFactory.newInstance();
            XPath myXPath = myXPathFactory.newXPath();

            //selezione di un valore stringa
            String myStringExpression = "/ieee1599/general/description/main_title/text()";
            String title = myXPath.evaluate(myStringExpression, myXmlDocument);
            System.out.println("Il titolo del brano e': " + title);

            //selezione di un nodo
            myStringExpression = "/ieee1599/general/description/author[position()=1]";
            Node author = (Node) (myXPath.compile(myStringExpression).evaluate(myXmlDocument, XPathConstants.NODE));
            System.out.println("Il nome del primo autore e': " + author.getTextContent());

            //selezione di un node-set
            myStringExpression = "//related_file";
            NodeList relatedFiles = (NodeList) (myXPath.evaluate(myStringExpression, myXmlDocument, XPathConstants.NODESET));
            for (int i = 0; i < relatedFiles.getLength(); i++) {
                String currentDescription = ((Element) (relatedFiles.item(i))).getAttribute("description");
                System.out.println("Il contenuto " + (i + 1) + " ha descrizione " + currentDescription);
            }
        } catch (Exception ex) {
            Logger.getLogger(JavaXPath.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

}
