package Package2;

class Note {

    private int cbr;

    public Note() {
        cbr = 0;
    }

    public Note(int octave, int pc, int nc) {
        if (octave < 0) {
            octave = 0;
        }
        pc = Math.min(11, pc);
        pc = Math.max(0, pc);
        nc = Math.min(6, nc);
        nc = Math.max(0, nc);
        cbr = octave * 1000 + pc * 10 + nc;
    }

    public int getOctave() {
        return cbr / 1000;
    }

    public int getPitchClass() {
        return (cbr % 1000) / 10;
    }

    public int getNameClass() {
        return (cbr % 10);
    }

    public void setOctave(int octave) {
        octave = Math.max(0, octave);
        cbr = (cbr % 1000) + octave * 1000;
    }

    public void setPitchClass(int pc) {
        pc = Math.min(11, pc);
        pc = Math.max(0, pc);
        cbr = (cbr / 1000) * 1000 + (cbr % 10) + pc * 10;
    }

    public void setNameClass(int nc) {
        nc = Math.min(6, nc);
        nc = Math.max(0, nc);
        cbr = (cbr / 10) * 10 + nc;
    }

    @Override
    public String toString() {
        return ("Cbr " + this.cbr + " -> Ottava " + this.getOctave() + "; Pitch class " + this.getPitchClass() + "; Name class " + this.getNameClass());
    }
}

// ------------------------------------------------------------------------
public class TestCbr {

    public static void main(String[] args) {
        // inizializzazione con valori validi
        Note n1 = new Note(1, 7, 3);
        System.out.println("Rappresentazione testuale: " + n1.toString());
        // gestione dei valori non validi
        Note n2 = new Note(-3, 12, 7);
        System.out.println("Rappresentazione testuale: " + n2.toString());
        n2.setOctave(2);
        n2.setNameClass(4);
        System.out.println("Rappresentazione testuale: " + n2.toString());
        n2.setPitchClass(1);
        System.out.println("Rappresentazione testuale: " + n2.toString());
    }

}
