package audio;

import java.io.IOException;

public class InvertEndianness {

  static byte[] invertStream(byte[] streamToSwap, int nBytes) {
    byte[] result = new byte[streamToSwap.length];
    int nSwaps = streamToSwap.length / nBytes;
    try {
      for (int i = 0; i < nSwaps; i++) {
        for (int k = 0; k < nBytes; k++) {
          result[i * nBytes + k] = streamToSwap[(i + 1) * nBytes - (k + 1)];
        }
      }
    } catch (Exception e) {
    }
    return result;
  }

  static String echo(byte[] byteStream) {
    String result = "";
    for (int i = 0; i < byteStream.length; i++) {
      result += String.format("0x%02X", byteStream[i]) + " "; // %02X indica di stampare su 2 cifre in esadecimale
    }
    return result;
  }

  public static void main(String[] args) throws InterruptedException, IOException {

    /*
     File fileToOpen = new File("foo.raw");
     if (!fileToOpen.isFile()) {
     System.exit(1);
     }
     // lettura del file byte per byte
     InputStream input = new FileInputStream(fileToOpen);
     byte[] originalStream = new byte[(int) fileToOpen.length()];
     for (int i = 0; i < fileToOpen.length(); i++) {
     originalStream[i] = (byte) input.read();
     }
     */
    byte[] originalStream = {0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0A, 0x0B, 0x0C};
    System.out.println("Stream originale: " + echo(originalStream));

    byte[] newStream1 = invertStream(originalStream, 1);
    System.out.println(echo(newStream1));

    byte[] newStream2 = invertStream(originalStream, 2);
    System.out.println(echo(newStream2));

    byte[] newStream4 = invertStream(originalStream, 4);
    System.out.println(echo(newStream4));

  }
}
