package jMusic;

import jm.JMC;
import jm.util.*;
import jm.music.data.*;
import jm.audio.*;

public class AudioDrums implements JMC {

    public static void main(String[] args) {
        Score s = new Score("AudioDrums");
        Part kickPart = new Part("Kick", 0, 9);
        Part snarePart = new Part("Snare", 1, 9);
        Part hatsPart = new Part("Hats", 2, 9);
        Part openHatsPart = new Part("OpenHats", 3, 9);
        Phrase kickPhrase = new Phrase();
        Phrase snarePhrase = new Phrase();
        Phrase hatsPhrase = new Phrase();
        Phrase openHatsPhrase = new Phrase();

        SimpleSampleInst kickInst = new SimpleSampleInst("Kick.au", FRQ[36]);
        SimpleSampleInst snareInst = new SimpleSampleInst("Snare.au", FRQ[38]);
        SimpleSampleInst hatsInst = new SimpleSampleInst("Hats.au", FRQ[42]);
        SimpleSampleInst openHatsInst = new SimpleSampleInst("HHOpen.au", FRQ[46]);
        Instrument[] drumKit = {kickInst, snareInst, hatsInst, openHatsInst};

        // kick 
        for (int i = 0; i < 2; i++) {
            Note n = new Note(36, HALF_NOTE);
            kickPhrase.addNote(n);
        }

        //snare
        for (int i = 0; i < 2; i++) {
            Note r = new Note(REST, QUARTER_NOTE);
            snarePhrase.addNote(r);
            Note n = new Note(38, QUARTER_NOTE);
            snarePhrase.addNote(n);
        }

        //hats
        for (int i = 0; i < 16; i++)
            if (i % 2 == 1 && Math.random() < 0.1) {
                Note n = new Note(46, SIXTEENTH_NOTE, 20 + (int) (Math.random() * 107));
                n.setDuration(n.getRhythmValue());
                openHatsPhrase.addNote(n);
                Note r = new Note(REST, SIXTEENTH_NOTE);
                hatsPhrase.addNote(r);
            } else {
                Note n = new Note(42, SIXTEENTH_NOTE, 20 + (int) (Math.random() * 107));
                n.setDuration(n.getRhythmValue());
                hatsPhrase.addNote(n);
                Note r = new Note(REST, SIXTEENTH_NOTE);
                openHatsPhrase.addNote(r);
            }

        //pack
        kickPart.addPhrase(kickPhrase);
        snarePart.addPhrase(snarePhrase);
        hatsPart.addPhrase(hatsPhrase);
        openHatsPart.addPhrase(openHatsPhrase);

        s.addPart(kickPart);
        s.addPart(snarePart);
        s.addPart(hatsPart);
        s.addPart(openHatsPart);

        //write midi
        Write.midi(s, "AudioDrums.mid");

        //write au
        Write.au(s, "AudioDrums.au", drumKit);
    }
}
