package jMusic;

import jm.audio.*;
import jm.audio.io.SampleOut;
import jm.audio.synth.*;

public class SampleInstrument2 extends jm.audio.Instrument {
    private int sampleRate;

    public SampleInstrument2(int sampleRate) {
        this.sampleRate = sampleRate;
    }

    @Override
    public void createChain() throws AOException {
        Oscillator osc1 = new Oscillator(this, Oscillator.SINE_WAVE, this.sampleRate);
        Volume volOsc1 = new Volume(osc1, 1.0);
        
        Oscillator osc2 = new Oscillator(this, Oscillator.SQUARE_WAVE, this.sampleRate);
        osc2.setFrqRatio(1.02);
        Volume volOsc2 = new Volume(osc2, 0.5);
        
        Noise noise = new Noise(this, Noise.WHITE_NOISE, this.sampleRate);
        Filter filter = new Filter(noise, 4000, Filter.HIGH_PASS);
        Volume volNoise = new Volume(filter, 0.3);
        
        AudioObject[] parts = {volOsc1, volOsc2, volNoise};
        Add add = new Add(parts);
        Envelope env = new Envelope(add, new EnvPoint[] {
                                        new EnvPoint(0.0f, 0.0f),
                                        new EnvPoint(0.2f, 1.0f),
                                        new EnvPoint(0.7f, 0.7f),
                                        new EnvPoint(0.9f, 0.1f),
                                        new EnvPoint(1.0f, 0.0f) });
        
        SampleOut sout = new SampleOut(env);
    }

}
